from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean

Kmasker_V0_1_0 = CommandToolBuilder(tool="Kmasker", base_command=["Kmasker"], inputs=[ToolInput(tag="in_build", input_type=Boolean(optional=True), prefix="--build", doc=InputDocumentation(doc="construction of new index (requires --seq)")), ToolInput(tag="in_run", input_type=Boolean(optional=True), prefix="--run", doc=InputDocumentation(doc="perform analysis and masking (requires --fasta)")), ToolInput(tag="in_explore", input_type=Boolean(optional=True), prefix="--explore", doc=InputDocumentation(doc="perform downstream analysis with constructed index and detected repeats")), ToolInput(tag="in_show_repository", input_type=Boolean(optional=True), prefix="--show_repository", doc=InputDocumentation(doc="show complete list of private and external k-mer indices")), ToolInput(tag="in_show_details", input_type=Boolean(optional=True), prefix="--show_details", doc=InputDocumentation(doc="show details for a requested kindex")), ToolInput(tag="in_show_path", input_type=Boolean(optional=True), prefix="--show_path", doc=InputDocumentation(doc="show path Kmaskers looks for constructed kindex")), ToolInput(tag="in_remove_k_index", input_type=Boolean(optional=True), prefix="--remove_kindex", doc=InputDocumentation(doc="remove kindex from repository")), ToolInput(tag="in_set_private_path", input_type=Boolean(optional=True), prefix="--set_private_path", doc=InputDocumentation(doc="change path to private repository")), ToolInput(tag="in_set_external_path", input_type=Boolean(optional=True), prefix="--set_external_path", doc=InputDocumentation(doc="change path to external repository [readonly]")), ToolInput(tag="in_expert_setting_km_asker", input_type=Boolean(optional=True), prefix="--expert_setting_kmasker", doc=InputDocumentation(doc="submit individual parameter to Kmasker eg. pctgap,\nminseed, mingff (see documentation!)")), ToolInput(tag="in_expert_setting_jelly", input_type=Boolean(optional=True), prefix="--expert_setting_jelly", doc=InputDocumentation(doc="submit individual parameter to jellyfish (e.g. on memory usage\nfor index construction)")), ToolInput(tag="in_expert_setting_blast", input_type=Boolean(optional=True), prefix="--expert_setting_blast", doc=InputDocumentation(doc="submit individual parameter to blast (e.g. '-evalue')")), ToolInput(tag="in_threads", input_type=Boolean(optional=True), prefix="--threads", doc=InputDocumentation(doc="set number of threads [4]")), ToolInput(tag="in_bed", input_type=Boolean(optional=True), prefix="--bed", doc=InputDocumentation(doc="force additional BED output [off]")), ToolInput(tag="in_user_conf", input_type=Boolean(optional=True), prefix="--user_conf", doc=InputDocumentation(doc="set specific user configuration file [/root/.kmasker_user.config]")), ToolInput(tag="in_global_conf", input_type=Boolean(optional=True), prefix="--global_conf", doc=InputDocumentation(doc="set specific global configuration file [/usr/local/etc/kmasker.config]")), ToolInput(tag="in_check_install", input_type=Boolean(optional=True), prefix="--check_install", doc=InputDocumentation(doc="shows the detected/configured path for all used applications")), ToolInput(tag="in_setid", input_type=Boolean(optional=True), prefix="--setid", doc=InputDocumentation(doc="set a user specified process id")), ToolInput(tag="in_long_id", input_type=Boolean(optional=True), prefix="--long_id", doc=InputDocumentation(doc="create a process id that is unique for this host (e.g. for use in cluster environments)")), ToolInput(tag="in_temp", input_type=Boolean(optional=True), prefix="--temp", doc=InputDocumentation(doc="sets the location of temporary files [./temp/]")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="enables verbose output and keeps log files")), ToolInput(tag="in_make_model", input_type=Boolean(optional=True), prefix="--make_model", doc=InputDocumentation(doc="For use with krispr: Build a new krispr model. You have to specifiy a .csv after this paramter. Details at https://git.io/JecYI. You can use -m to specify the coverage threshold."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Kmasker_V0_1_0().translate("wdl", allow_empty_container=True)

